unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, Unit2;

type
  TForm1 = class(TForm)
    Panel4: TPanel;
    Label11: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Label12: TLabel;
    Panel5: TPanel;
    ButtonChangeResol: TButton;
    ButtonRevenir: TButton;
    Panel3: TPanel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Panel2: TPanel;
    Label4: TLabel;
    Button8Bits: TButton;
    Button16Bits: TButton;
    Button32Bits: TButton;
    SpinEditCouleur: TSpinEdit;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Button800x600: TButton;
    SpinEditLargeur: TSpinEdit;
    SpinEditHauteur: TSpinEdit;
    Button1024x768: TButton;
    Button1280x1024: TButton;
    Label13: TLabel;
    procedure Button800x600Click(Sender: TObject);
    procedure Button1024x768Click(Sender: TObject);
    procedure Button8BitsClick(Sender: TObject);
    procedure Button16BitsClick(Sender: TObject);
    procedure Button32BitsClick(Sender: TObject);
    procedure ButtonChangeResolClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonRevenirClick(Sender: TObject);
    procedure Button1280x1024Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  AncienneResolutionWidth:Integer;
  AncienneResolutionHeight:Integer;
  AncienneResolutionCouleur:Integer;

function ChangeResolEcran(Largeur,Hauteur, ColorResolution:integer):Integer;

implementation

{$R *.DFM}


function ChangeResolEcran(Largeur,Hauteur, ColorResolution:integer):Integer;
var
  Retour:Longint;
  DevMode:TDeviceMode;
begin
  DevMode.dmSize:=SizeOf(DevMode);
  DevMode.dmPelsWidth:=Largeur;
  DevMode.dmPelsHeight:=Hauteur;
  DevMode.dmBitsPerPel:=ColorResolution;
  DevMode.dmFields:=DM_BITSPERPEL+DM_PELSWIDTH+DM_PELSHEIGHT; //indique ce que l'on veut modifier.
  Retour := ChangeDisplaySettings(DevMode, CDS_TEST); //CDS_TEST car ce que l'on veut en premier, c'est voir si c'est possible
  if Retour=DISP_CHANGE_RESTART then ShowMessage('ne peut modifier la rsolution car ncessiterait un redmarrage de Windows');
  if Retour=DISP_CHANGE_SUCCESSFUL then ChangeDisplaySettings(DevMode, CDS_UPDATEREGISTRY);// l, c'est bon
  if Retour=DISP_CHANGE_FAILED	then ShowMessage('erreur');
  if Retour=DISP_CHANGE_BADMODE then ShowMessage('Mode Graphique non support');
  Result:=Retour;
end;

function ChangeFrequence(Frequence:integer):Integer;
var
  Retour:Longint;
  DevMode:TDeviceMode;
begin
  DevMode.dmSize:=SizeOf(DevMode);
  DevMode.dmDisplayFrequency:=Frequence;
  DevMode.dmFields:=DM_DISPLAYFREQUENCY; //indique ce que l'on veut modifier.
  Retour := ChangeDisplaySettings(DevMode, CDS_TEST); //CDS_TEST car ce que l'on veut en premier, c'est voir si c'est possible
  if Retour=DISP_CHANGE_RESTART then ShowMessage('ne peut modifier la rsolution car ncessiterait un redmarrage de Windows');
  if Retour=DISP_CHANGE_SUCCESSFUL then ChangeDisplaySettings(DevMode, CDS_UPDATEREGISTRY);// l, c'est bon, on le fait pour de bon.
  if Retour=DISP_CHANGE_FAILED	then ShowMessage('erreur');
  if Retour=DISP_CHANGE_BADMODE then ShowMessage('Mode Graphique non support');
  Result:=Retour;
end;

Procedure MemorisationResolution;
begin
   AncienneResolutionWidth:=Screen.Width;
   AncienneResolutionHeight:=Screen.Height;
   AncienneResolutionCouleur:=GetDeviceCaps(Form1.Canvas.Handle, BITSPIXEL)*GetDeviceCaps(Form1.Canvas.Handle, PLANES);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  MemorisationResolution;
  Label8.Caption:=IntToStr(AncienneResolutionWidth);
  Label9.Caption:=IntToStr(AncienneResolutionHeight);
  Label10.Caption:=IntToStr(AncienneResolutionCouleur);
end;

procedure TForm1.Button800x600Click(Sender: TObject);
begin
  SpinEditLargeur.Value:=800;
  SpinEditHauteur.Value:=600;
end;

procedure TForm1.Button1024x768Click(Sender: TObject);
begin
  SpinEditLargeur.Value:=1024;
  SpinEditHauteur.Value:=768;
end;

procedure TForm1.Button1280x1024Click(Sender: TObject);
begin
  SpinEditLargeur.Value:=1280;
  SpinEditHauteur.Value:=1024;
end;

procedure TForm1.Button8BitsClick(Sender: TObject);
begin
  SpinEditCouleur.Value:=8;
end;

procedure TForm1.Button16BitsClick(Sender: TObject);
begin
  SpinEditCouleur.Value:=16;
end;

procedure TForm1.Button32BitsClick(Sender: TObject);
begin
  SpinEditCouleur.Value:=32;
end;

procedure TForm1.ButtonChangeResolClick(Sender: TObject);
begin
  if ChangeResolEcran(SpinEditLargeur.Value,SpinEditHauteur.Value, SpinEditCouleur.Value)=DISP_CHANGE_SUCCESSFUL
    then Form2.ShowModal;
end;


procedure TForm1.ButtonRevenirClick(Sender: TObject);
begin
   ChangeResolEcran(AncienneResolutionWidth,AncienneResolutionHeight, AncienneResolutionCouleur);
end;



procedure TForm1.Button1Click(Sender: TObject);
begin
  ChangeFrequence(60);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ChangeFrequence(0);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ChangeFrequence(70);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  ChangeFrequence(75);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  ChangeFrequence(85);
end;

end.



